
#+TITLE:
#+AUTHOR:VLEAD
#+DATE:#+SETUPFILE: ./org-templates/level-0.org
#+TAGS: boilerplate(b)
#+EXCLUDE_TAGS: boilerplate
#+OPTIONS: ^:nil

* Javascript code for Red Blactree practice


** Constructor for the red black tree. It takes the canvas as 'am', width and heigh as parameters

+We are doing a sort of "faked" inheritance within javascript. We define our function, 
set the prototype of our function to the prototype of our superclass, 
reset the constructor to be our own constructor, 
and then cache the superclass prototype, for simulating a java-style "super" call. 

+Notice that to make inheritance work well on counstructors, we don't do anything 
in the main constructor function other than call an 
init function (that way we can have our init function call the init 
function of the superclass. Yes, this is a bit of a hack.)
#+NAME: Inheritance
#+BEGIN_SRC js

function displayComment(text)
{
	$('#nextcomment').html(text);
}

function RedBlack(am, w, h)
{
	this.init(am, w, h);
}

RedBlack.prototype = new Algorithm();
RedBlack.prototype.constructor = RedBlack;
RedBlack.superclass = Algorithm.prototype;

RedBlack.prototype.init = function(am, w, h)
{
	var sc = RedBlack.superclass;
	var fn = sc.init;
	fn.call(this,am);
	this.addControls();
	this.nextIndex = 1;
	this.commands = [];
	this.startingX = w / 3;
	this.print_max  = w - PRINT_HORIZONTAL_GAP;
	this.first_print_pos_y  = h - 2 * PRINT_VERTICAL_GAP;

	this.cmd("CreateLabel", 0, "", EXPLANITORY_TEXT_X, EXPLANITORY_TEXT_Y, 0);
	this.animationManager.StartNewAnimation(this.commands);
	this.animationManager.skipForward();
	this.animationManager.clearHistory();
}

#+END_SRC

** Function that adds controls to the top bar of the artefacts and shows buttons and text boxes.

+Next up is the method to add algorithm controls and callbacks. 
The tricky bit here is that we can't do something like:
this.popButton.onclick = this.popCallback
to add our callbacks. 

+Why not? 
This would pass in the proper function, but not the proper contex -- essentially, 
it would be passing a pointer to the code of the function, without saving the "this" pointer. 

+So we need to bind the "this" pointer to our function before we store it.

#+NAME: AddControls
#+BEGIN_SRC js




RedBlack.prototype.addControls =  function()
{
	
	this.insertButton = document.getElementById("control-exer-root");
	this.insertButton.onclick = this.generateCallback.bind(this);
	this.insertLeftButton = document.getElementById("control-exer-insert-l");
	this.insertLeftButton.onclick=this.insertLeftCallback.bind(this);
	this.insertRightButton = document.getElementById("control-exer-insert-r");
	this.insertRightButton.onclick=this.insertRightCallback.bind(this);
	this.leftrotateButton = document.getElementById("control-exer-rotate-l");
	this.leftrotateButton.onclick=this.leftrotateCallback.bind(this);
	this.rightrotateButton = document.getElementById("control-exer-rotate-r");
	this.rightrotateButton.onclick=this.rightrotateCallback.bind(this);
	this.submitButton = document.getElementById("control-exer-submit");
	this.submitButton.onclick=this.submitCallback.bind(this);
	this.showStepsButton = document.getElementById("control-exer-steps");
	this.showStepsButton.onclick=this.showStepsCallBack.bind(this);
	this.showStepsButton.disabled=true;
	this.showStepsButton.style.backgroundColor="gray";
	this.showStepsButton.style.border="gray";
	this.resetButton = document.getElementById("control-exer-reset");
	this.resetButton.onclick=this.reset.bind(this);	
	this.showNullLeaves = document.getElementById("control-exer-null");
	this.showNullLeaves.onclick = this.showNullLeavesCallback.bind(this);
	this.showNullLeaves.checked = false;

}

#+END_SRC



** Function resets the operations that were done on the tree.

+All visualizations must implement the reset method. 
The reset method needs to restore all of our variables to the state that they were 
in right after the call to init. 


#+NAME: Reset
#+BEGIN_SRC js	


RedBlack.prototype.reset = function()
{
	this.nextIndex = 1;
	this.treeRoot = null;
	ptr=1;
	stepschosen=[];
	document.getElementById("nextcomment").innerHTML="";
	document.getElementById("nextelement").innerHTML="";
	for(k=0;k<insertedvaluelist.length;k++)
	{
			animationManager.skipBack();
		
	}
	
	this.insertButton.disabled=false
}
#+END_SRC



** Declaration of variables for positioning the artefacts

#+NAME: Declaration
#+BEGIN_SRC js


var FIRST_PRINT_POS_X = 50;
var PRINT_VERTICAL_GAP = 20;
var PRINT_HORIZONTAL_GAP = 50;


var FOREGROUND_RED = "#AA0000";
var BACKGROUND_RED = "#FFAAAA";

var FOREGROUND_BLACK =  "#000000"
var BACKGROUND_BLACK = "#AAAAAA";
var BACKGROUND_DOUBLE_BLACK = "#777777";


var HIGHLIGHT_LABEL_COLOR = "#FF0000"
var HIGHLIGHT_LINK_COLOR = "#FF0000"

var BLUE = "#0000FF";

var LINK_COLOR = "#000000"
var BACKGROUND_COLOR = BACKGROUND_BLACK;
var HIGHLIGHT_COLOR = "#007700";
var FOREGROUND_COLOR = FOREGROUND_BLACK;
var PRINT_COLOR = FOREGROUND_COLOR

var widthDelta  = 50;
var heightDelta = 50;
var startingY = 50;


var FIRST_PRINT_POS_X  = 20;
var PRINT_VERTICAL_GAP  = 20;
var PRINT_HORIZONTAL_GAP = 50;
var EXPLANITORY_TEXT_X = 10;
var EXPLANITORY_TEXT_Y = 10;
var insertedvaluelist=[3,2,5,10,12];
var steps=["left","right","right","rightrotate"]
var reasons=["2 is lessser than 3,hence we go left","5 is greater than 3,hence we go right",
"10 is greater than 3,no imbalance caused","12 is greater than 3,rotation done to remove imbalance"]
var ptr=1



#+END_SRC

** Callback function for generating  the root node
+The callback function generates the root node of the tree to be displayed on the screen.
+The insertedvaluelist contains the nodes to be displayed.And the first element of this array is being rendered on the screen.


#+NAME: generateCallBack
#+BEGIN_SRC js

var stepschosen=[]
RedBlack.prototype.generateCallback=function(event)
{
	
	var insertedValue = parseInt(insertedvaluelist[0],10);
		if (insertedValue != "")
		{
			
				this.implementAction(this.insertElement.bind(this), insertedValue);
				
					document.getElementById("nextelement").innerHTML=insertedvaluelist[1]
				
					
		}
		this.insertButton.disabled=true;
		
	
}

#+END_SRC


** This function is called when the user submits the answer on the exercise page to be checked

+When the user clicks the submit button, this function is called.

+This function submits the answer for checking and activates the show steps button.

+This also shows the user, the first step where they went wrong.

#+NAME: submitCallBack
#+BEGIN_SRC js
RedBlack.prototype.submitCallback=function(event)
{
	
	i=0;
	wrong=false
	wrongsteps=[];
	for(i=0;i<steps.length;i++)
	{
		if(steps[i]!=stepschosen[i])
		{
			wrongsteps.push(i)
			wrong=true;
			break;
		}
		
		
	};
	
	if(wrong==false)
	{
		
		
		document.getElementById("nextcomment").innerHTML="Correct.All steps chosen are correct."
		
	}
	else
	{
			string1="Wrong Answer\n.First Step where you went wrong."
			
				string1=string1+reasons[wrongsteps[0]]+"\n";
				
			
			document.getElementById("nextcomment").innerHTML=string1;
			
		
		
	}
	
	var k=1;
	
	ptr=1;
	
	this.showStepsButton.disabled=false;	
	this.showStepsButton.style.backgroundColor="#3297CF";
		this.showStepsButton.style.border="#3297CF";
	
	
	
	
	
	
}

#+END_SRC


** Function is called when the user wants to know the step by step solution to the exercise problem. This is done by click show steps button

+After the user has submitted the answer for exercise. We provide the facility to check the answer step by step.

+This button is activated only after a submission.


#+NAME: wrongsteps
#+BEGIN_SRC js




RedBlack.prototype.showStepsCallBack=function(event)
{
	
	

		if(ptr<insertedvaluelist.length){
		console.log("hey")
		var insertedValue = parseInt(insertedvaluelist[ptr],10);
		console.log(insertedValue)


		if (insertedValue != "")
		{

			this.implementAction(this.insertElement.bind(this), insertedValue);
			if(ptr+1<insertedvaluelist.length)
			document.getElementById("nextelement").innerHTML=insertedvaluelist[ptr+1]
			else
			document.getElementById("nextelement").innerHTML="No More Values to insert"

		}

	}
	
	
	ptr=ptr+1

}
#+END_SRC


** Callback functions for steps

+The below callback functions keep track of the steps the user has selected while exploring 
the artefacts.
+The leftrotate callback inserts the leftrotate step into the stepschosen array, which would be later used for checking the right stpes.


#+NAME: leftrotate
#+BEGIN_SRC js
RedBlack.prototype.leftrotateCallback=function(event)
{
	
	document.getElementById("nextcomment").innerHTML="Step chosen: insert left and rotate"
	stepschosen.push("leftrotate")
	this.shownext(this)
	ptr+=1
}

#+END_SRC

+The rightrotate callback inserts the rightrotate step into the stepschosen array, which would be later used for checking the right stpes.


#+NAME: rightrotate
#+BEGIN_SRC js




RedBlack.prototype.rightrotateCallback=function(event)
{
	
	document.getElementById("nextcomment").innerHTML="Step chosen: insert right and rotate"
	stepschosen.push("righrotate")
	this.shownext(this)
	ptr+=1
	
	
}
#+END_SRC

+The shownext callback displays the next element to be inserted onto the given tree.
+Based on this value,user would know which step to choose next.

#+NAME: shownext
#+BEGIN_SRC js





RedBlack.prototype.shownext=function(event)
{
	if(ptr+1<insertedvaluelist.length)
		document.getElementById("nextelement").innerHTML=insertedvaluelist[ptr+1]
	else
		document.getElementById("nextelement").innerHTML="No more values to insert"
		
}

#+END_SRC

+The insertright callback inserts the insert right step into the stepschosen array, which would be later used for checking the right stpes.


#+NAME: insertRight
#+BEGIN_SRC js





RedBlack.prototype.insertRightCallback=function(event)
{
	document.getElementById("nextcomment").innerHTML="Step chosen: insert right"
	stepschosen.push("right")
	this.shownext(this)
	ptr+=1

}

#+END_SRC

+The  insertLeftCallback  inserts the insertLeftCallback  step into the stepschosen array, which would be later used for checking the right steps.


#+NAME: insertLeft
#+BEGIN_SRC js




RedBlack.prototype.insertLeftCallback = function(event)
{
	
	
	document.getElementById("nextcomment").innerHTML="Step chosen: insert left"
	stepschosen.push("left")
	this.shownext(this)
	ptr+=1
	
	
}
#+END_SRC


** Function is called whenever an insert operation is performed on the tree after click the Insert Button rendered on the UI.

+The insert callback function does not perform any insert operation on its own. It makes a call to the implementAction function, the implement action function receives two arguments - a bounded function and the value to be inserted in to the tree. 
+The implementAction function then makes a call to the function it receives along the value to be inserted. The insert operation is performed thereafter.

#+NAME: insertCallback
#+BEGIN_SRC js

RedBlack.prototype.insertCallback = function(event,k)
{
	var insertedValue = parseInt(insertedvaluelist[k],10);
	console.log("inserting",insertedValue)
	if (insertedValue != "")
	{
		this.implementAction(this.insertElement.bind(this), insertedValue);
		if(k+1<insertedvaluelist.length)
			document.getElementById("nextelement").innerHTML=insertedvaluelist[k+1]
		else
			document.getElementById("nextelement").innerHTML="No More Values to insert"
	}
}


#+END_SRC
	
** Function is called whenever a delete operation is performed on the tree and handles the delete operation.

+The actual delete operation does not happen in the deleteCallback function as with all the callback functions that we have implemented. 
+Here also, we make a call to the implementAction function which takes in deleteElement function and the value to be deleted as parameters. The deleteElement function then performs the actual delete operation.

#+NAME: DeleteCallback
#+BEGIN_SRC js
RedBlack.prototype.deleteCallback = function(event)
{
	var deletedValue = this.deleteField.value;
	if (deletedValue != "")
	{
		deletedValue = this.normalizeNumber(deletedValue, 1);
		this.deleteField.value = "";
		this.implementAction(this.deleteElement.bind(this),deletedValue);		
	}
}

#+END_SRC
** Function called when a find/search operation is performed on the tree.

+The find callback function is called when we perform a find operation on the red black tree. Like other callback functions that we have defined here the actual find operation does not happen here. 

+We make a call to the implementAction function and pass it two parameters, one is the function which performs the actual find and the other is the argument to the function, which is the key we need to find in the tree.



#+NAME: findCallback
#+BEGIN_SRC js



RedBlack.prototype.findCallback = function(event)
{
	var findValue = this.findField.value;
	if (findValue != "")
	{
		findValue = this.normalizeNumber(findValue, 1);
		this.findField.value = "";
		this.implementAction(this.findElement.bind(this),findValue);		
	}
}

#+END_SRC


** Function is called when the print functionality of the tree is invoked.

+This function makes a call to the implementAction function and does not directly implement the print functionality. Like any other callback function which we have defined here, a printTree function is passed as an argument to implementAction. 

+This function then performs the actual printing of the nodes. 

#+NAME: PrintCallback
#+BEGIN_SRC js



RedBlack.prototype.printCallback = function(event)
{
	this.implementAction(this.printTree.bind(this),"");						
}


#+END_SRC


** Function to display all the Null leaves.

+This function makes a call to the set All layout, which handles the rendering of null leaves on the screen.

+When the user checks the show null leaves check box, the showNullLeaves.checked boolean variable is set to true and the null leaves are rendered. 

#+NAME: nulleaves
#+BEGIN_SRC js



RedBlack.prototype.showNullLeavesCallback = function(event)
{
	if (this.showNullLeaves.checked)
	{
		this.animationManager.setAllLayers([0,1]);		
	}
	else
	{
		this.animationManager.setAllLayers([0]);
	}
}

#+END_SRC
** Function prints the tree nodes, essentially performs a traversal on the tree.

+This is the function that actually performs the printing of nodes in the tree. 

+Since, a tree by definition is a recursive data structure we need to have a recursive function which traverses the tree in a level order and prints the element, printTreeRec is such a recursive function being called from here.

#+NAME: PrintTree
#+BEGIN_SRC js	
RedBlack.prototype.printTree = function(unused)
{
	this.commands = [];
	
	if (this.treeRoot != null)
	{
		this.highlightID = this.nextIndex++;
		var firstLabel = this.nextIndex;
		this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, this.treeRoot.x, this.treeRoot.y);
		this.xPosOfNextLabel = FIRST_PRINT_POS_X;
		this.yPosOfNextLabel = this.first_print_pos_y;
		this.printTreeRec(this.treeRoot);
		this.cmd("Delete",this.highlightID);
		this.cmd("Step");
		for (var i = firstLabel; i < this.nextIndex; i++)
			this.cmd("Delete", i);
		this.nextIndex = this.highlightID;  /// Reuse objects.  Not necessary.
	}
	return this.commands;
}

#+END_SRC



** Function prints the tree in a recursive order.

+The tree by definition is a recursive data structure. The print operation given here prints the tree in a recursive order. The function starts from the root of the tree and print all the keys in the root, and then recursively the keys in left subtree and right subtree.

+The function then moves on to the next next level starting from the left most child of the root. 
#+NAME: PrintTreeRecursive
#+BEGIN_SRC js		

RedBlack.prototype.printTreeRec = function(tree) 
{
	this.cmd("Step");
	if (tree.left != null && !tree.left.phantomLeaf)
	{
		this.cmd("Move", this.highlightID, tree.left.x, tree.left.y);
		this.printTreeRec(tree.left);
		this.cmd("Move", this.highlightID, tree.x, tree.y);				
		this.cmd("Step");
	}
	var nextLabelID = this.nextIndex++;
	this.cmd("CreateLabel", nextLabelID, tree.data, tree.x, tree.y);
	this.cmd("SetForegroundColor", nextLabelID, PRINT_COLOR);
	this.cmd("Move", nextLabelID, this.xPosOfNextLabel, this.yPosOfNextLabel);
	this.cmd("Step");
	
	this.xPosOfNextLabel +=  PRINT_HORIZONTAL_GAP;
	if (this.xPosOfNextLabel > this.print_max)
	{
		this.xPosOfNextLabel = FIRST_PRINT_POS_X;
		this.yPosOfNextLabel += PRINT_VERTICAL_GAP;
		
	}
	if (tree.right != null && !tree.right.phantomLeaf)
	{
		this.cmd("Move", this.highlightID, tree.right.x, tree.right.y);
		this.printTreeRec(tree.right);
		this.cmd("Move", this.highlightID, tree.x, tree.y);	
		this.cmd("Step");
	}
	return;
}


#+END_SRC
** Function performs the find functionality on the tree, receives the element to be searched in the arguments.

+This is the function that actually performs the find operation in the tree. Since a tree is a recursive data structure, we need to recursively traverse the tree in order to find any key in it. 

#+NAME: FindElement
#+BEGIN_SRC js

RedBlack.prototype.findElement = function(findValue)
{
	this.commands = [];
	
	this.highlightID = this.nextIndex++;
	
	this.doFind(this.treeRoot, findValue);
	
	
	return this.commands;
}


RedBlack.prototype.doFind = function(tree, value)
{
	this.cmd("SetText", 0, "Searchiing for "+value);
	if (tree != null && !tree.phantomLeaf)
	{
		this.cmd("SetHighlight", tree.graphicID, 1);
		if (tree.data == value)
		{
			this.cmd("SetText", 0, "Searching for "+value+" : " + value + " = " + value + " (Element found!)");
			this.cmd("Step");
			this.cmd("SetText", 0, "Found:"+value);
			this.cmd("SetHighlight", tree.graphicID, 0);
		}
		else
		{
			if (tree.data > value)
			{
				this.cmd("SetText", 0, "Searching for "+value+" : " + value + " < " + tree.data + " (look to left subtree)");
				this.cmd("Step");
				this.cmd("SetHighlight", tree.graphicID, 0);
				if (tree.left!= null)
				{
					this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
					this.cmd("Move", this.highlightID, tree.left.x, tree.left.y);
					this.cmd("Step");
					this.cmd("Delete", this.highlightID);
				}
				this.doFind(tree.left, value);
			}
			else
			{
				this.cmd("SetText", 0, " Searching for "+value+" : " + value + " > " + tree.data + " (look to right subtree)");					
				this.cmd("Step");
				this.cmd("SetHighlight", tree.graphicID, 0);
				if (tree.right!= null)
				{
					this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
					this.cmd("Move", this.highlightID, tree.right.x, tree.right.y);
					this.cmd("Step");
					this.cmd("Delete", this.highlightID);				
				}
				this.doFind(tree.right, value);						
			}
			
		}
		
	}
	else
	{
		this.cmd("SetText", 0, " Searching for "+value+" : " + "< Empty Tree > (Element not found)");				
		this.cmd("Step");					
		this.cmd("SetText", 0, " Searching for "+value+" : " + " (Element not found)");					
	}
}
#+END_SRC

** Function to determine the uncle node

+The uncle node is the sibling of the parent node of the concered node.
+If the parent is null, we return null
+Also left child of grandparent node is the sibling node of the parent of the concerned node,if the concerned node is in right subtree.
+Also right child of grandparent node is the sibling node of the parent of the concerned node,if the concerned node is in left subtree.


#+NAME: findUncle
#+BEGIN_SRC js

RedBlack.prototype.findUncle = function(tree)
{
	if (tree.parent == null)
	{
		return null;
	}
	var par  = tree.parent;
	if (par.parent == null)
	{
		return null;
	}
	var grandPar   = par.parent;
	
	if (grandPar.left == par)
	{
		return grandPar.right;
	}
	else
	{
		return grandPar.left;
	}				
}

#+END_SRC

** Function to return the black level

+ used internally while deletion process is going on for checking violation of black level.

#+NAME: blacklevel
#+BEGIN_SRC js




RedBlack.prototype.blackLevel = function(tree)
{
	if (tree == null)
	{
		return 1;
	}
	else
	{
		return tree.blackLevel;
	}
}

#+END_SRC




** Function to attach null leaves to a node


+The attach null leaves internally calls both attachleftnulleaf and attachrightnulleaf.
+Each of the functions initiliazes a new red black node with background and foreground set to black color. 


#+NAME: attachnullleaves
#+BEGIN_SRC js

RedBlack.prototype.attachLeftNullLeaf = function(node)
{

	var treeNodeID = this.nextIndex++;
	this.cmd("CreateCircle", treeNodeID, "NULL\nLEAF",  node.x, node.y);
	this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_BLACK);
	this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_BLACK);
	node.left = new RedBlackNode("", treeNodeID, this.startingX, startingY);
	node.left.phantomLeaf = true;
	this.cmd("SetLayer", treeNodeID, 1);
	node.left.blackLevel = 1;
	this.cmd("Connect",node.graphicID, treeNodeID, LINK_COLOR);
}	

RedBlack.prototype.attachRightNullLeaf = function(node)
{

	treeNodeID = this.nextIndex++;
	this.cmd("CreateCircle", treeNodeID, "NULL\nLEAF",  node.x, node.y);
	this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_BLACK);
	this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_BLACK);
	node.right = new RedBlackNode("", treeNodeID, this.startingX, startingY);
	this.cmd("SetLayer", treeNodeID, 1);
	
	node.right.phantomLeaf = true;
	node.right.blackLevel = 1;
	this.cmd("Connect", node.graphicID, treeNodeID, LINK_COLOR);
	
}
RedBlack.prototype.attachNullLeaves = function(node)
{
	this.attachLeftNullLeaf(node);
	this.attachRightNullLeaf(node);
}

#+END_SRC





** Wrapper Function to insert node into a red black tree 

+If the root node is null, a new circle object is created, and colored in black as per the algorithm.
+Null leaves are attached to the created node by calling the attachNullLeaves function declared above.
+If the root is not null, the new node is  created and internally the insert() function is called, which handles which subtree to insert the element in.



#+NAME: insertWrapper
#+BEGIN_SRC js






RedBlack.prototype.insertElement = function(insertedValue)
{
	this.commands = new Array();	
	this.cmd("SetText", 0, " Inserting "+insertedValue);
	this.highlightID = this.nextIndex++;
	var treeNodeID;
	if (this.treeRoot == null)
	{
		treeNodeID = this.nextIndex++;
		this.cmd("CreateCircle", treeNodeID, insertedValue,  this.startingX, startingY);
		this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_BLACK);
		this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_BLACK);
		this.treeRoot = new RedBlackNode(insertedValue, treeNodeID, this.startingX, startingY);
		this.treeRoot.blackLevel = 1;
		
		this.attachNullLeaves(this.treeRoot);
		this.resizeTree();
		
	}
	else
	{
		treeNodeID = this.nextIndex++;
		
		this.cmd("CreateCircle", treeNodeID, insertedValue, 30, startingY);
		this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_RED);
		this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_RED);
		this.cmd("Step");				
		var insertElem = new RedBlackNode(insertedValue, treeNodeID, 100, 100)
		
		this.cmd("SetHighlight", insertElem.graphicID, 1);
		insertElem.height = 1;
		this.insert(insertElem, this.treeRoot);
			
	}
	this.cmd("SetText", 0, " ");				
	return this.commands;
}
#+END_SRC




** Function to handle single rotation of the tree


+singleRotateRight Handles the right rotation and singleRotateLeft handles the left rotation.
+For right rotation,the right subtree is moved to the left subtree.
+The values of left subtree are stored in t1,t2.
+If the right subtree of left subtree,t2 is not null, the root node passed is made as the parent of this subtree.

+Similary for left rotation,
If the left subtree of right subtree,t2 is not null, the root node passed is made as the parent of this subtree.


#+NAME: rotations
#+BEGIN_SRC js
RedBlack.prototype.singleRotateRight = function(tree)
{
	var B = tree;
	var t3 = B.right;
	var A = tree.left;
	var t1 = A.left;
	var t2 = A.right;
	
	this.cmd("SetText", 0, "Single Rotate Right");
	this.cmd("SetEdgeHighlight", B.graphicID, A.graphicID, 1);
	this.cmd("Step");
	

	
	if (t2 != null)
	{
		this.cmd("Disconnect", A.graphicID, t2.graphicID); 
		this.cmd("Connect", B.graphicID, t2.graphicID, LINK_COLOR);
		t2.parent = B;
	}
	this.cmd("Disconnect", B.graphicID, A.graphicID);
	this.cmd("Connect", A.graphicID, B.graphicID, LINK_COLOR);
	
	A.parent = B.parent;
	if (this.treeRoot == B)
	{
		this.treeRoot = A;
	}
	else
	{
		this.cmd("Disconnect", B.parent.graphicID, B.graphicID, LINK_COLOR);
		this.cmd("Connect", B.parent.graphicID, A.graphicID, LINK_COLOR)
		if (B.isLeftChild())
		{
			B.parent.left = A;
		}
		else
		{
			B.parent.right = A;
		}
	}
	A.right = B;
	B.parent = A;
	B.left = t2;
	this.resetHeight(B);
	this.resetHeight(A);
	this.resizeTree();			
	return A;
}



RedBlack.prototype.singleRotateLeft = function(tree) 
{
	var A = tree;
	var B = tree.right;
	var t1 = A.left;
	var t2 = B.left;
	var t3 = B.right;
	
	this.cmd("SetText", 0, "Single Rotate Left");
	this.cmd("SetEdgeHighlight", A.graphicID, B.graphicID, 1);
	this.cmd("Step");
	
	if (t2 != null)
	{
		this.cmd("Disconnect", B.graphicID, t2.graphicID);																		  
		this.cmd("Connect", A.graphicID, t2.graphicID, LINK_COLOR);
		t2.parent = A;
	}
	this.cmd("Disconnect", A.graphicID, B.graphicID);
	this.cmd("Connect", B.graphicID, A.graphicID, LINK_COLOR);
	B.parent = A.parent;
	if (this.treeRoot == A)
	{
		this.treeRoot = B;
	}
	else
	{
		this.cmd("Disconnect", A.parent.graphicID, A.graphicID, LINK_COLOR);
		this.cmd("Connect", A.parent.graphicID, B.graphicID, LINK_COLOR)
		
		if (A.isLeftChild())
		{
			A.parent.left = B;
		}
		else
		{
			A.parent.right = B;
		}
	}
	B.left = A;
	A.parent = B;
	A.right = t2;
	this.resetHeight(A);
	this.resetHeight(B);
	
	this.resizeTree();
	return B;
}



#+END_SRC

	

** Function to return height and reset height

+getHeight is a getter function for getting the height of the red black tree.
+resetHeight resets the height of tree ,if the structure of tree has changed after performing a rotate operation above.



#+NAME: heightfunctions
#+BEGIN_SRC js


RedBlack.prototype.getHeight = function(tree) 
{
	if (tree == null)
	{
		return 0;
	}
	return tree.height;
}

RedBlack.prototype.resetHeight = function(tree)
{
	if (tree != null)
	{
		var newHeight = Math.max(this.getHeight(tree.left), this.getHeight(tree.right)) + 1;
		if (tree.height != newHeight)
		{
			tree.height = Math.max(this.getHeight(tree.left), this.getHeight(tree.right)) + 1
		}
	}
}


#+END_SRC


** Function to implement the actual insert algorithm of the red black tree.



+The insert function is called by the insertWrapper function when the tree root is not null.

+ If the the value of the node is greater than the root node, the the node is inserted in the right subtree.
+If the value of the node is less than the root node , the node is inserted in the left subtree.

+ If the left subtree is not null, it is recursively called till a single null lead, also called as phatom leaf found and then the node is inserted.


+ Similarly,If the right subtree is not null, it is recursively called till a single null lead, also called as phatom leaf found and then the node is inserted.

#+NAME: insertAlgorithm
#+BEGIN_SRC js



RedBlack.prototype.insert = function(elem, tree)
{
	this.cmd("SetHighlight", tree.graphicID, 1);
	this.cmd("SetHighlight", elem.graphicID, 1);
	
	if (elem.data < tree.data)
	{
		this.cmd("SetText", 0, elem.data + " < " + tree.data + ".  Looking at left subtree");				
	}
	else
	{
		this.cmd("SetText",  0, elem.data + " >= " + tree.data + ".  Looking at right subtree");				
	}
	this.cmd("Step");
	this.cmd("SetHighlight", tree.graphicID , 0);
	this.cmd("SetHighlight", elem.graphicID, 0);
	
	if (elem.data < tree.data)
	{
		if (tree.left == null || tree.left.phantomLeaf)
		{
			this.cmd("SetText", 0, "Found null tree (or phantom leaf), inserting element");				
			if (tree.left != null)
			{
				this.cmd("Delete", tree.left.graphicID);
			}
			this.cmd("SetHighlight", elem.graphicID, 0);
			tree.left=elem;
			elem.parent = tree;
			this.cmd("Connect", tree.graphicID, elem.graphicID, LINK_COLOR);
			
			this.attachNullLeaves(elem);
			this.resizeTree();
			
			
			
			
			this.resizeTree();
			
			this.fixDoubleRed(elem);
			
		}
		else
		{
			this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
			this.cmd("Move", this.highlightID, tree.left.x, tree.left.y);
			this.cmd("Step");
			this.cmd("Delete", this.highlightID);
			this.insert(elem, tree.left);
			
		}
	}
	else
	{
		if (tree.right == null  || tree.right.phantomLeaf)
		{
			this.cmd("SetText",  0, "Found null tree (or phantom leaf), inserting element");
			if (tree.right != null)
			{
				this.cmd("Delete", tree.right.graphicID);
			}
			
			this.cmd("SetHighlight", elem.graphicID, 0);
			tree.right=elem;
			elem.parent = tree;
			this.cmd("Connect", tree.graphicID, elem.graphicID, LINK_COLOR);
			elem.x = tree.x + widthDelta/2;
			elem.y = tree.y + heightDelta
			this.cmd("Move", elem.graphicID, elem.x, elem.y);
			
			
			this.attachNullLeaves(elem);
			this.resizeTree();
			
			
			this.resizeTree();
			this.fixDoubleRed(elem);
		}
		else
		{
			this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
			this.cmd("Move", this.highlightID, tree.right.x, tree.right.y);
			this.cmd("Step");
			this.cmd("Delete", this.highlightID);
			this.insert(elem, tree.right);
		}
	}
	
	
}


#+END_SRC
** Function to fix double red case in red black tree.
+ This function is used in some intricate cases arising in insert and deletion operations.
+ If the root is red, we color is black.
+ When the node and parent are red,uncle of node is red, we push blackness from grandparent, by setting the black level variable of the uncle to 1, parent to 1,grandparent to 0 and recursively calling the function on the grandparent, as the violation has now been shifted upwards.
+ If node,parent are both red  Node is right child, parent is left child, then singlerotateleft function is called.

+ If node,parent are both red  Node is left child, parent is right child, then singlerotateright function is called.


#+NAME: doublered
#+BEGIN_SRC js



RedBlack.prototype.fixDoubleRed = function(tree)
{
	if (tree.parent != null)
	{
		if (tree.parent.blackLevel > 0)
		{
			return;
		}
		if (tree.parent.parent == null)
		{
			this.cmd("SetText", 0, "Tree root is red, color it black.");
			this.cmd("Step");
			tree.parent.blackLevel = 1;
			this.cmd("SetForegroundColor", tree.parent.graphicID, FOREGROUND_BLACK);
			this.cmd("SetBackgroundColor", tree.parent.graphicID, BACKGROUND_BLACK);
			return;
		}
		var uncle = this.findUncle(tree);
		if (this.blackLevel(uncle) == 0)
		{
			this.cmd("SetText", 0, "Node and parent are both red.  Uncle of node is red -- push blackness down from grandparent");
			this.cmd("Step");
			
			this.cmd("SetForegroundColor", uncle.graphicID, FOREGROUND_BLACK);
			this.cmd("SetBackgroundColor",uncle.graphicID, BACKGROUND_BLACK);
			uncle.blackLevel = 1;
			
			tree.parent.blackLevel = 1;
			this.cmd("SetForegroundColor", tree.parent.graphicID, FOREGROUND_BLACK);
			this.cmd("SetBackgroundColor",tree.parent.graphicID, BACKGROUND_BLACK);
			
			tree.parent.parent.blackLevel = 0;
			this.cmd("SetForegroundColor", tree.parent.parent.graphicID, FOREGROUND_RED);
			this.cmd("SetBackgroundColor",tree.parent.parent.graphicID, BACKGROUND_RED);
			this.cmd("Step");
			this.fixDoubleRed(tree.parent.parent);
		}
		else
		{
			if (tree.isLeftChild() &&  !tree.parent.isLeftChild())
			{
				this.cmd("SetText", 0, "Node and parent are both red.  Node is left child, parent is right child -- rotate");
				this.cmd("Step");
				
				this.singleRotateRight(tree.parent);
				tree=tree.right;
				
			}
			else if (!tree.isLeftChild() && tree.parent.isLeftChild())
			{
				this.cmd("SetText", 0, "Node and parent are both red.  Node is right child, parent is left child -- rotate");
				this.cmd("Step");
				
				this.singleRotateLeft(tree.parent);
				tree=tree.left;
			}
			
			if (tree.isLeftChild())
			{
				this.cmd("SetText", 0, "Node and parent are both red.  Node is left child, parent is left child\nCan fix extra redness with a single rotation");
				this.cmd("Step");
				
				this.singleRotateRight(tree.parent.parent);
				tree.parent.blackLevel = 1;
				this.cmd("SetForegroundColor", tree.parent.graphicID, FOREGROUND_BLACK);
				this.cmd("SetBackgroundColor",tree.parent.graphicID, BACKGROUND_BLACK);
				
				tree.parent.right.blackLevel = 0;
				this.cmd("SetForegroundColor", tree.parent.right.graphicID, FOREGROUND_RED);
				this.cmd("SetBackgroundColor",tree.parent.right.graphicID, BACKGROUND_RED);						
				
				
			}
			else
			{
				this.cmd("SetText", 0, "Node and parent are both red.  Node is right child, parent is right child\nCan fix extra redness with a single rotation");
				this.cmd("Step");
				
				this.singleRotateLeft(tree.parent.parent);
				tree.parent.blackLevel = 1;
				this.cmd("SetForegroundColor", tree.parent.graphicID, FOREGROUND_BLACK);
				this.cmd("SetBackgroundColor",tree.parent.graphicID, BACKGROUND_BLACK);
				
				tree.parent.left.blackLevel = 0;
				this.cmd("SetForegroundColor", tree.parent.left.graphicID, FOREGROUND_RED);
				this.cmd("SetBackgroundColor",tree.parent.left.graphicID, BACKGROUND_RED);				
				
			}					
		}
		
	}
	else
	{
		if (tree.blackLevel == 0)
		{
			this.cmd("SetText", 0, "Root of the tree is red.  Color it black");
			this.cmd("Step");
			
			tree.blackLevel = 1;
			this.cmd("SetForegroundColor", tree.graphicID, FOREGROUND_BLACK);
			this.cmd("SetBackgroundColor", tree.graphicID, BACKGROUND_BLACK);
		}
	}
	
}
#+END_SRC
** Wrapper function for delete operation.
+ The function internally calls treeDelete, which handles the intricate cases of deletion algorithm
#+NAME: delete
#+BEGIN_SRC js


RedBlack.prototype.deleteElement = function(deletedValue)
{
	this.commands = new Array();
	this.cmd("SetText", 0, "Deleting "+deletedValue);
	this.cmd("Step");
	this.cmd("SetText", 0, " ");
	this.highlightID = this.nextIndex++;
	this.treeDelete(this.treeRoot, deletedValue);
	this.cmd("SetText", 0, " ");			
	// Do delete
	return this.commands;						
}

#+END_SRC
** Fixing Null leaves
+ The function is called, when the node deleted is a black node, and to retain the black depth we convert the node to double black node.
+ The function fixLeftNull, convert the left subtree to double black node.
+ The function fixRightNull, converts the right subtee to double black node.


#+NAME: fixingNullLeaves
#+BEGIN_SRC js


RedBlack.prototype.fixLeftNull = function(tree)
{
	var treeNodeID = this.nextIndex++;
	var nullLeaf;
	this.cmd("SetText", 0, "Coloring 'Null Leaf' double black");
	
	this.cmd("CreateCircle", treeNodeID, "NULL\nLEAF",  tree.x, tree.y);
	this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_BLACK);
	this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_DOUBLE_BLACK);
	nullLeaf = new RedBlackNode("NULL\nLEAF", treeNodeID, tree.x, tree.x);
	nullLeaf.blackLevel = 2;
	nullLeaf.parent = tree;
	nullLeaf.phantomLeaf = true;
	tree.left = nullLeaf;
	this.cmd("Connect", tree.graphicID, nullLeaf.graphicID, LINK_COLOR);
	
	this.resizeTree();				
	this.fixExtraBlackChild(tree, true);
	this.cmd("SetLayer", nullLeaf.graphicID, 1);
	nullLeaf.blackLevel = 1;
	this.fixNodeColor(nullLeaf);
}


RedBlack.prototype.fixRightNull = function(tree)
{
	var treeNodeID = this.nextIndex++;
	var nullLeaf;
	this.cmd("SetText", 0, "Coloring 'Null Leaf' double black");
	
	this.cmd("CreateCircle", treeNodeID, "NULL\nLEAF",  tree.x, tree.y);
	this.cmd("SetForegroundColor", treeNodeID, FOREGROUND_BLACK);
	this.cmd("SetBackgroundColor", treeNodeID, BACKGROUND_DOUBLE_BLACK);
	nullLeaf = new RedBlackNode("NULL\nLEAF", treeNodeID, tree.x, tree.x);
	nullLeaf.parent = tree;
	nullLeaf.phantomLeaf = true;
	nullLeaf.blackLevel = 2;
	tree.right = nullLeaf;
	this.cmd("Connect", tree.graphicID, nullLeaf.graphicID, LINK_COLOR);
	
	this.resizeTree();				
	
	this.fixExtraBlackChild(tree, false);
	
	this.cmd("SetLayer", nullLeaf.graphicID, 1);
	nullLeaf.blackLevel = 1;
	this.fixNodeColor(nullLeaf);
	
}
#+END_SRC


** Function to fix extra black node.
+ The black level of the node is checked.

+ If the node is double black node and  has black sibling and 2 black nephews, then we push up the black level, making the subling black level to 0,the parent node black level to 2 and pushing the double black to parent node.
+The function is then recusrively called on the double  black parent node.


#+NAME: fixingExtraBlackSubPart1
#+BEGIN_SRC js

RedBlack.prototype.fixExtraBlackChild = function(parNode, isLeftChild)
{
	var sibling;
	var doubleBlackNode;
	if (isLeftChild)
	{
		sibling = parNode.right;
		doubleBlackNode = parNode.left;
	}
	else
	{
		sibling = parNode.left;				
		doubleBlackNode = parNode.right;
	}
	if (this.blackLevel(sibling) > 0 && this.blackLevel(sibling.left) > 0 && this.blackLevel(sibling.right) > 0)
	{
		this.cmd("SetText", 0, "Double black node has black sibling and 2 black nephews.  Push up black level");
		this.cmd("Step");
		sibling.blackLevel = 0;
		this.fixNodeColor(sibling);
		if (doubleBlackNode != null)
		{
			doubleBlackNode.blackLevel = 1;
			this.fixNodeColor(doubleBlackNode);
			
		}
		if (parNode.blackLevel == 0)
		{
			parNode.blackLevel = 1;
			this.fixNodeColor(parNode);
		}
		else
		{
			parNode.blackLevel = 2;
			this.fixNodeColor(parNode);
			this.cmd("SetText", 0, "Pushing up black level created another double black node.  Repeating ...");
			this.cmd("Step");
			this.fixExtraBlack(parNode);
		}				
	}
	else if (this.blackLevel(sibling) == 0)
	{
		this.cmd("SetText", 0, "Double black node has red sibling.  Rotate tree to make sibling black ...");
		this.cmd("Step");
		if (isLeftChild)
		{
			var newPar = this.singleRotateLeft(parNode);
			newPar.blackLevel = 1;
			this.fixNodeColor(newPar);
			newPar.left.blackLevel = 0;
			this.fixNodeColor(newPar.left);
			this.cmd("Step"); // TODO:  REMOVE
			this.fixExtraBlack(newPar.left.left);
			
		}
		else
		{
			newPar  = this.singleRotateRight(parNode);
			newPar.blackLevel = 1;
			this.fixNodeColor(newPar);
			newPar.right.blackLevel = 0;
			this.fixNodeColor(newPar.right);
			this.cmd("Step"); // TODO:  REMOVE

			this.fixExtraBlack(newPar.right.right);
		}
	}
#+END_SRC
+ If the double black node has black sibling, but double black node is a left child, and the right nephew is black, the tree is rotate to make oppposite nephew red.
+The blacklevel of opposite nephew is set to 0, the function is recursvely called on the parent node.

+ If the double black node has black sibling, but double black node is a right child, and the leftt nephew is black, the tree is rotate to make opposite nephew red.
+The blacklevel of opposite nephew is set to 0, the function is recursvely called on the parent node.



#+NAME: fixingExtraBlackSubPart2
#+BEGIN_SRC js
	else if (isLeftChild && this.blackLevel(sibling.right) > 0)
	{
		this.cmd("SetText", 0, "Double black node has black sibling, but double black node is a left child, \nand the right nephew is black.  Rotate tree to make opposite nephew red ...");
		this.cmd("Step");
		
		var newSib = this.singleRotateRight(sibling);
		newSib.blackLevel = 1;
		this.fixNodeColor(newSib);
		newSib.right.blackLevel = 0;
		this.fixNodeColor(newSib.right);
		this.cmd("Step");
		this.fixExtraBlackChild(parNode, isLeftChild);
	}
	else if (!isLeftChild && this.blackLevel(sibling.left) > 0)
	{
		this.cmd("SetText", 0, "Double black node has black sibling, but double black node is a right child, \nand the left nephew is black.  Rotate tree to make opposite nephew red ...");
		this.cmd("Step");
		newSib = this.singleRotateLeft(sibling);
		newSib.blackLevel = 1;
		this.fixNodeColor(newSib);
		newSib.left.blackLevel = 0;
		this.fixNodeColor(newSib.left);
		this.cmd("Step");
		this.fixExtraBlackChild(parNode, isLeftChild);
	}
	else if (isLeftChild)
	{
		this.cmd("SetText", 0, "Double black node has black sibling, is a left child, and its right nephew is red.\nOne rotation can fix double-blackness.");
		this.cmd("Step");
		
		var oldParBlackLevel  = parNode.blackLevel;
		newPar = this.singleRotateLeft(parNode);
		if (oldParBlackLevel == 0)
		{
			newPar.blackLevel = 0;
			this.fixNodeColor(newPar);
			newPar.left.blackLevel = 1;
			this.fixNodeColor(newPar.left);
		}
		newPar.right.blackLevel = 1;
		this.fixNodeColor(newPar.right);
		if (newPar.left.left != null)
		{
			newPar.left.left.blackLevel = 1;
			this.fixNodeColor(newPar.left.left);
		}
	}
	else
	{
		this.cmd("SetText", 0, "Double black node has black sibling, is a right child, and its left nephew is red.\nOne rotation can fix double-blackness.");
		this.cmd("Step");
		
		oldParBlackLevel  = parNode.blackLevel;
		newPar = this.singleRotateRight(parNode);
		if (oldParBlackLevel == 0)
		{
			newPar.blackLevel = 0;
			this.fixNodeColor(newPar);
			newPar.right.blackLevel = 1;
			this.fixNodeColor(newPar.right);
		}
		newPar.left.blackLevel = 1;
		this.fixNodeColor(newPar.left);
		if (newPar.right.right != null)
		{
			newPar.right.right.blackLevel = 1;
			this.fixNodeColor(newPar.right.right);
		}
	}
}
#+END_SRC
** Fixing double black nodes
+ The black node level is checked.
+ If the node is double black and is root, we simply make it single black by setting the black level to 1.
+ For other cases, we called the fix extra black child function.


#+NAME: fixDoubleBlack
#+BEGIN_SRC js
 

RedBlack.prototype.fixExtraBlack = function(tree)
{
	if (tree.blackLevel > 1)
	{
		if (tree.parent == null)
		{
			this.cmd("SetText", 0, "Double black node is root.  Make it single black.");
			this.cmd("Step");
			
			tree.blackLevel = 1;
			this.cmd("SetBackgroundColor", tree.graphicID, BACKGROUND_BLACK);
		}
		else if (tree.parent.left == tree)
		{
			this.fixExtraBlackChild(tree.parent, true);
		}
		else
		{
			this.fixExtraBlackChild(tree.parent, false);					
		}
		
	}
	else 
	{
		// No extra blackness
	}
}
#+END_SRC
** Deletion Algorithm


+ The deletion algorithm takes, the root node of the tree and the value to be deleted as parameters.
+The valueToDelete is compared with the data of the root node and then decided which subtree contains the value to be deleted.
+ If the valueToDelete is less than data of the root node, the left subtree is searched, else the right subtree.
+This function is called recursively till we get the the node to be deleted. if it is not found we reach a phatomLeaf and return.



#+NAME: deletionAlgorithmSubpart1
#+BEGIN_SRC js








RedBlack.prototype.treeDelete = function(tree, valueToDelete)
{
	var leftchild = false;
	if (tree != null && !tree.phantomLeaf)
	{
		if (tree.parent != null)
		{
			leftchild = tree.parent.left == tree;
		}
		this.cmd("SetHighlight", tree.graphicID, 1);
		if (valueToDelete < tree.data)
		{	
			this.cmd("SetText", 0, valueToDelete + " < " + tree.data + ".  Looking at left subtree");				
		}
		else if (valueToDelete > tree.data)
		{
			this.cmd("SetText", 0, valueToDelete + " > " + tree.data + ".  Looking at right subtree");				
		}
		else
		{
			this.cmd("SetText", 0, valueToDelete + " == " + tree.data + ".  Found node to delete");									
		}
		this.cmd("Step");
		this.cmd("SetHighlight", tree.graphicID, 0);
		



#+END_SRC


+ If the value to be deleted is found, we now check if the black level needs a fix or not.
+ If the left and right child are null, the command is sent to delete the particular node, and then check if the deletion violates any black level property.

#+NAME: deletionAlgorithmSubpart2
#+BEGIN_SRC js



		if (valueToDelete == tree.data)
		{
			var needFix = tree.blackLevel > 0;
			if (((tree.left == null) || tree.left.phantomLeaf)  && ((tree.right == null) || tree.right.phantomLeaf))
			{
				this.cmd("SetText",  0, "Node to delete is a leaf.  Delete it.");
				this.cmd("Delete", tree.graphicID);
				
				if (tree.left != null)
				{
					this.cmd("Delete", tree.left.graphicID);
				}
				if (tree.right != null)
				{
					this.cmd("Delete", tree.right.graphicID);
				}
				
				
				if (leftchild && tree.parent != null)
				{
					tree.parent.left = null;
					this.resizeTree();				
					
					if (needFix)
					{
						this.fixLeftNull(tree.parent);
					}
					else
					{
						
						this.attachLeftNullLeaf(tree.parent);
						this.resizeTree();
					}
				}
				else if (tree.parent != null)
				{
					tree.parent.right = null;
					this.resizeTree();		
					if (needFix)
					{
						this.fixRightNull(tree.parent);
					}
					else
					{
						this.attachRightNullLeaf(tree.parent);
						this.resizeTree();
					}
				}
				else
				{
					this.treeRoot = null;
				}
				
			}

#+END_SRC

+ If the value to be deleted is found, we now check if the black level needs a fix or not.
+ If ony the left subtree is null, the parent of deleted node is set to right child of deleted node.

#+NAME: deletionAlgorithmSubpart3
#+BEGIN_SRC js


			else if (tree.left == null || tree.left.phantomLeaf)
			{
				this.cmd("SetText", 0, "Node to delete has no left child.  \nSet parent of deleted node to right child of deleted node.");									
				if (tree.left != null)
				{
					this.cmd("Delete", tree.left.graphicID);
					tree.left = null;
				}
				
				if (tree.parent != null)
				{
					this.cmd("Disconnect", tree.parent.graphicID, tree.graphicID);
					this.cmd("Connect", tree.parent.graphicID, tree.right.graphicID, LINK_COLOR);
					this.cmd("Step");
					this.cmd("Delete", tree.graphicID);
					if (leftchild)
					{
						tree.parent.left = tree.right;
						if (needFix)
						{
							this.cmd("SetText", 0, "Back node removed.  Increasing child's blackness level");
							tree.parent.left.blackLevel++;
							this.fixNodeColor(tree.parent.left);
							this.fixExtraBlack(tree.parent.left);
						}
					}
					else
					{
						tree.parent.right = tree.right;
						if (needFix)
						{
							tree.parent.right.blackLevel++;
							this.cmd("SetText", 0, "Back node removed.  Increasing child's blackness level");
							this.fixNodeColor(tree.parent.right);
							this.fixExtraBlack(tree.parent.right);
						}
						
					}
					tree.right.parent = tree.parent;
				}
				else
				{
					this.cmd("Delete", tree.graphicID);
					this.treeRoot = tree.right;
					this.treeRoot.parent = null;
					if (this.treeRoot.blackLevel == 0)
					{
						this.treeRoot.blackLevel = 1;
						this.cmd("SetForegroundColor", this.treeRoot.graphicID, FOREGROUND_BLACK);
						this.cmd("SetBackgroundColor", this.treeRoot.graphicID, BACKGROUND_BLACK);		
					}
				}
				this.resizeTree();
			}



#+END_SRC


+ If the value to be deleted is found, we now check if the black level needs a fix or not.
+ If ony the right subtree is null, the parent of deleted node is set to left child of deleted node.
+
#+NAME: deletionAlgorithmSubpart4
#+BEGIN_SRC js




			else if (tree.right == null || tree.right.phantomLeaf)
			{
				this.cmd("SetText",  0,"Node to delete has no right child.  \nSet parent of deleted node to left child of deleted node.");
				if (tree.right != null)
				{
					this.cmd("Delete", tree.right.graphicID);
					tree.right = null;					
				}
				if (tree.parent != null)
				{
					this.cmd("Disconnect", tree.parent.graphicID, tree.graphicID);
					this.cmd("Connect", tree.parent.graphicID, tree.left.graphicID, LINK_COLOR);
					this.cmd("Step");
					this.cmd("Delete", tree.graphicID);
					if (leftchild)
					{
						tree.parent.left = tree.left;
						if (needFix)
						{
							tree.parent.left.blackLevel++;
							this.fixNodeColor(tree.parent.left);
							this.fixExtraBlack(tree.parent.left);
							this.resizeTree();
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.resizeTree();
								
						}
					}
					else
					{
						tree.parent.right = tree.left;
						if (needFix)
						{
							tree.parent.right.blackLevel++;
							this.fixNodeColor(tree.parent.right);
							this.fixExtraBlack(tree.parent.left);
							this.resizeTree();
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.resizeTree();								
						}
					}
					tree.left.parent = tree.parent;
				}
				else
				{
					this.cmd("Delete" , tree.graphicID);
					this.treeRoot = tree.left;
					this.treeRoot.parent = null;
					if (this.treeRoot.blackLevel == 0)
					{
						this.treeRoot.blackLevel = 1;
						this.fixNodeColor(this.treeRoot);
					}
				}
			}


#+END_SRC
+ If the value to be deleted is found, we now check if the black level needs a fix or not.
+ If none of the subtrees are null, we have arrived at 2 children case, where we find the largest node in left subtree, which is also called the inorder succesor of the node.

+To find the inorder successor, we go the left child and keep traversing the right subtree of this left subtree, till we reach the phatom leaf.
+the tmp variables holds the left child. The while loop runs till the right child of the tmp variable is not null.

#+NAME: deletionAlgorithmSubpart5
#+BEGIN_SRC js




			else // tree.left != null && tree.right != null
			{
				this.cmd("SetText", 0, "Node to delete has two childern.  \nFind largest node in left subtree.");									
				
				this.highlightID = this.nextIndex;
				this.nextIndex += 1;
				this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
				var tmp = tree;
				tmp = tree.left;
				this.cmd("Move", this.highlightID, tmp.x, tmp.y);
				this.cmd("Step");																									
				while (tmp.right != null && !tmp.right.phantomLeaf)
				{
					tmp = tmp.right;
					this.cmd("Move", this.highlightID, tmp.x, tmp.y);
					this.cmd("Step");																									
				}
				if (tmp.right != null)
				{
					this.cmd("Delete", tmp.right.graphicID);
					tmp.right = null;
				}
				this.cmd("SetText", tree.graphicID, " ");
				var labelID = this.nextIndex;
				this.nextIndex += 1;
				this.cmd("CreateLabel", labelID, tmp.data, tmp.x, tmp.y);
				this.cmd("SetForegroundColor", labelID, BLUE);
				tree.data = tmp.data;
				this.cmd("Move", labelID, tree.x, tree.y);
				this.cmd("SetText", 0, "Copy largest value of left subtree into node to delete.");									
				
				this.cmd("Step");
				this.cmd("SetHighlight", tree.graphicID, 0);
				this.cmd("Delete", labelID);
				this.cmd("SetText", tree.graphicID, tree.data);
				this.cmd("Delete", this.highlightID);							
				this.cmd("SetText", 0, "Remove node whose value we copied.");									
				
				needFix = tmp.blackLevel > 0;
				
				
				if (tmp.left == null)
				{
					this.cmd("Delete", tmp.graphicID);
					if (tmp.parent != tree)
					{
						tmp.parent.right = null;
						this.resizeTree();
						if (needFix)
						{
							this.fixRightNull(tmp.parent);
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.cmd("Step");									
						}
					}
					else
					{
						tree.left = null;
						this.resizeTree();
						if (needFix)
						{
							this.fixLeftNull(tmp.parent);
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.cmd("Step");									
						}
					}
				}
				else
				{
					this.cmd("Disconnect", tmp.parent.graphicID, tmp.graphicID);
					this.cmd("Connect", tmp.parent.graphicID, tmp.left.graphicID, LINK_COLOR);
					this.cmd("Step");
					this.cmd("Delete", tmp.graphicID);
					
					if (tmp.parent != tree)
					{
						tmp.parent.right = tmp.left; 
						tmp.left.parent = tmp.parent;
						this.resizeTree();
						
						if (needFix)
						{
							this.cmd("SetText", 0, "Coloring child of deleted node black");
							this.cmd("Step");
							tmp.left.blackLevel++;
							if (tmp.left.phantomLeaf)
							{
								this.cmd("SetLayer", tmp.left.graphicID, 0);
							}
							this.fixNodeColor(tmp.left);
							this.fixExtraBlack(tmp.left);
							if (tmp.left.phantomLeaf)
							{
								this.cmd("SetLayer", tmp.left.graphicID, 1);
							}
							
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.cmd("Step");									
						}
					}
					else
					{
						tree.left = tmp.left;
						tmp.left.parent = tree;
						this.resizeTree();
						if (needFix)
						{
							this.cmd("SetText", 0, "Coloring child of deleted node black");
							this.cmd("Step");
							tmp.left.blackLevel++;
							if (tmp.left.phantomLeaf)
							{
								this.cmd("SetLayer", tmp.left.graphicID, 0);
							}
							
							this.fixNodeColor(tmp.left);
							this.fixExtraBlack(tmp.left);
							if (tmp.left.phantomLeaf)
							{
								this.cmd("SetLayer", tmp.left.graphicID, 1);
							}
							
						}
						else
						{
							this.cmd("SetText", 0, "Deleted node was red.  No tree rotations required.");									
							this.cmd("Step");									
						}
					}
				}
				tmp = tmp.parent;
				
			}
		}


#+END_SRC
+If the value to be deleted is less than the root node data, we recursively call the delete function on the left subtree, which ultimately reduces to the above mentioned cases.

#+NAME: deletionAlgorithmSubpart6
#+BEGIN_SRC js	
		else if (valueToDelete < tree.data)
		{
			if (tree.left != null)
			{
				this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
				this.cmd("Move", this.highlightID, tree.left.x, tree.left.y);
				this.cmd("Step");
				this.cmd("Delete", this.highlightID);
			}
			this.treeDelete(tree.left, valueToDelete);
		}
		else
		{
			if (tree.right != null)
			{
				this.cmd("CreateHighlightCircle", this.highlightID, HIGHLIGHT_COLOR, tree.x, tree.y);
				this.cmd("Move", this.highlightID, tree.right.x, tree.right.y);
				this.cmd("Step");
				this.cmd("Delete", this.highlightID);
			}
			this.treeDelete(tree.right, valueToDelete);					
		}
	}
	else
	{
		this.cmd("SetText", 0, "Elemet "+valueToDelete+" not found, could not delete");
	}
	
}


#+END_SRC

** Function to fix the node color.
+If the black node is removed, we have to recolor the node to red, hence black level is checked.
+If the black level is reduced, we recolor the black node to double black.

#+NAME: fixNodeColor
#+BEGIN_SRC js



RedBlack.prototype.fixNodeColor = function(tree)
{
	if (tree.blackLevel == 0)
	{
		this.cmd("SetForegroundColor", tree.graphicID, FOREGROUND_RED);
		this.cmd("SetBackgroundColor", tree.graphicID, BACKGROUND_RED);									
	}
	else
	{
		this.cmd("SetForegroundColor", tree.graphicID, FOREGROUND_BLACK);
		if (tree.blackLevel > 1)
		{
			this.cmd("SetBackgroundColor",tree.graphicID, BACKGROUND_DOUBLE_BLACK);			
		}
		else
		{
			this.cmd("SetBackgroundColor",tree.graphicID, BACKGROUND_BLACK);
		}
	}
}


#+END_SRC

** Function resizes the tree according to the start_x and start_y coordinate.
#+NAME: ResizeTree
#+BEGIN_SRC js



RedBlack.prototype.resizeTree = function()
{
	var startingPoint  = this.startingX;
	this.resizeWidths(this.treeRoot);
	if (this.treeRoot != null)
	{
		if (this.treeRoot.leftWidth > startingPoint)
		{
			startingPoint = this.treeRoot.leftWidth;
		}
		else if (this.treeRoot.rightWidth > startingPoint)
		{
			startingPoint = Math.max(this.treeRoot.leftWidth, 2 * startingPoint - this.treeRoot.rightWidth);
		}
		this.setNewPositions(this.treeRoot, startingPoint, startingY, 0);
		this.animateNewPositions(this.treeRoot);
		this.cmd("Step");
	}
	
}

#+END_SRC


** Function to calculate new positions.
+Functions calculate new positions based on root node, x and y positions.


#+NAME: calculatepositions
#+BEGIN_SRC js





RedBlack.prototype.setNewPositions = function(tree, xPosition, yPosition, side)
{
	if (tree != null)
	{
		tree.y = yPosition;
		if (side == -1)
		{
			xPosition = xPosition - tree.rightWidth;
			tree.heightLabelX = xPosition - 20;
		}
		else if (side == 1)
		{
			xPosition = xPosition + tree.leftWidth;
			tree.heightLabelX = xPosition + 20;
		}
		else
		{
			tree.heightLabelX = xPosition - 20;
		}
		tree.x = xPosition;
		tree.heightLabelY = tree.y - 20;
		this.setNewPositions(tree.left, xPosition, yPosition + heightDelta, -1)
		this.setNewPositions(tree.right, xPosition, yPosition + heightDelta, 1)
	}
	
}
RedBlack.prototype.animateNewPositions = function(tree)
{
	if (tree != null)
	{
		this.cmd("Move", tree.graphicID, tree.x, tree.y);
		this.animateNewPositions(tree.left);
		this.animateNewPositions(tree.right);
	}
}
#+END_SRC
** Function resizes width according to initial positions.

#+NAME: resizeWidth
#+BEGIN_SRC js

RedBlack.prototype.resizeWidths = function(tree) 
{
	if (tree == null)
	{
		return 0;
	}
	tree.leftWidth = Math.max(this.resizeWidths(tree.left), widthDelta / 2);
	tree.rightWidth = Math.max(this.resizeWidths(tree.right), widthDelta / 2);
	return tree.leftWidth + tree.rightWidth;
}

#+END_SRC


** Function disables the UI during the animation play so that no other operation or control is available while animation is being played out.

+Called by our superclass when we get an animation started event -- need to wait for the
event to finish before we start doing anything

#+NAME: DisableUI
#+BEGIN_SRC js

RedBlack.prototype.disableUI = function(event)
{
	
	this.insertButton.disabled = true;
	
	
	this.insertLeftButton.disabled=true;
	this.insertRightButton.disabled=true;
	this.leftrotateButton.disabled=true;
	this.rightrotateButton.disabled=true;
	this.submitButton.disabled=true;
	
}
#+END_SRC

** Function enables click on the UI after the animation has been played out

+Called by our superclass when we get an animation completed event -- we can now interact again.

#+NAME: EnableUI
#+BEGIN_SRC js	


RedBlack.prototype.enableUI = function(event)
{

	this.insertButton.disabled = false;
	this.insertLeftButton.disabled=false;
	this.insertRightButton.disabled=false;
	this.leftrotateButton.disabled=false;
	this.rightrotateButton.disabled=false;
	this.submitButton.disabled=false;

}




#+END_SRC



** Function takes in the id, intial pos_X and pos_Y and initialises the tree node. 

+Determines where the node will get displayed. This function also declares the initial structure for the redblack node. 

+Also, a node can have left and right  subtree. There we declare approrpiate data structures here for this.

#+NAME: TreeNode
#+BEGIN_SRC js

function RedBlackNode(val, id, initialX, initialY)
{
	this.data = val;
	this.x = initialX;
	this.y = initialY;
	this.blackLevel = 0;
	this.phantomLeaf = false;
	this.graphicID = id;
	this.left = null;
	this.right = null;
	this.parent = null;
	this.height = 0;
	this.leftWidth = 0;
	this.rightWidth = 0;
}

RedBlackNode.prototype.isLeftChild = function()
{
	if (this.parent == null)
	{
		return true;
	}
	return this.parent.left == this;
}
#+END_SRC


** Function initialises the canvas on which the tree is rendered and is called first from the UI. 

+It is reponsible for inital setup for rendering. This canvas is then passed to the two three tree constructor as am argument.

#+NAME: InitializeAndRunTree
#+BEGIN_SRC js

var currentAlg;

function init()
{
	var animManag = initCanvas();
	currentAlg = new RedBlack(animManag, canvas.width, canvas.height);
}




#+END_SRC

* Tangle
#+BEGIN_SRC js :tangle RedBlackExercise.js :eval no :noweb yes

<<Inheritance>>
<<AddControls>>
<<Reset>>
<<Declaration>>
<<generateCallBack>>
<<submitCallBack>>
<<wrongsteps>>
<<leftrotate>>
<<rightrotate>>
<<shownext>>
<<insertRight>>
<<insertLeft>>
<<insertCallback>>
<<DeleteCallback>>
<<findCallback>>
<<PrintCallback>>
<<nulleaves>>
<<PrintTree>>
<<PrintTreeRecursive>>
<<FindElement>>
<<findUncle>>
<<blacklevel>>
<<attachnullleaves>>
<<insertWrapper>>
<<rotations>>
<<heightfunctions>>
<<insertAlgorithm>>
<<doublered>>
<<delete>>
<<fixingNullLeaves>>
<<fixingExtraBlackSubPart1>>
<<fixingExtraBlackSubPart2>>
<<fixDoubleBlack>>
<<deletionAlgorithmSubpart1>>
<<deletionAlgorithmSubpart2>>
<<deletionAlgorithmSubpart3>>
<<deletionAlgorithmSubpart4>>
<<deletionAlgorithmSubpart5>>
<<deletionAlgorithmSubpart6>>
<<fixNodeColor>>
<<ResizeTree>>
<<calculatepositions>>
<<resizeWidth>>
<<DisableUI>>
<<EnableUI>>
<<TreeNode>>
<<InitializeAndRunTree>>
#+END_SRC




